# encoding: utf8
#
#  El sistema masa-resorte-amortiguador 
# sujeto a fuenzas que cambian rápidamente:
# 
#  t=0, f = 2
#  t=2, f = 4
#  t=4, f = 1 
#  t=6, f = 5
#
# Fraga 30/10/2017

class SMRA :
	def __init__( self, m, b, k ) :
		self.m = m
		self.b = b
		self.k = k
		self.dt = 1.0/30.0
		self.k1 = 2.0 - self.dt*b/m - self.dt*self.dt*k/m
		self.k2 = self.dt*b/m - 1.0  
		self.k3 = 0.0
		self.x = 0.0
		self.x_1 = 0.0

	def pone_fuerza( self, f ) :
		self.k3 = self.dt*self.dt*f/self.m


	def simula( self, t0, tiempo ) :
		pasos = int(tiempo * 30)
		i = 0
		while i < pasos :
			x1 = self.k1*self.x + self.k2*self.x_1 + self.k3
			t = t0 + i * self.dt
			print t, x1 
			self.x_1 = self.x
			self.x = x1
			i += 1

smra = SMRA( 0.1, 0.25, 1 )
smra.pone_fuerza( 2 ) 
smra.simula( 0, 1.0/30 )

smra.pone_fuerza( 4 ) 
smra.simula( 1.0/30, 1.0/30 )

smra.pone_fuerza( 1 ) 
smra.simula( 2.0/30, 1.0/30 )

smra.pone_fuerza( 5 ) 
smra.simula( 3.0/30, 2 )
